#include <assert.h>
#include "bitmap.h"
#include"ezwin.h"
#include"rect.h"
#include"circle.h"
#include"triangle.h"
#include"square.h"
#include<time.h>
#include<cmath>
#include<iostream>
#include<cstdio>
#include<string>
#include<fstream>
using namespace std;
//including all the required header files

#define thck 0.01
#define lftdflt 5
#define rghtdflt 15
#define windowlength 23
#define windowheight 15.5
#define diff 0.01//difference
#define factor 100 //factor
#define radius 0.1
#define g 10
#define Pi 3.141
//defining the macros

SimpleWindow levelerror("ERROR",10.0,5.0,Position(5.0,2.5));
SimpleWindow instruct("Instructions",10.2,12.3,Position(5.0,2.5));
SimpleWindow mainwindow("Pocket Tanks-IIT Bombay",windowlength,windowheight,Position(0.0,0.0));
SimpleWindow crdts("MADE BY:",16.3,10.0,Position(1.0,1.5));
SimpleWindow highscores("Highscores",10.0,10.0,Position(5.0,5.0));
SimpleWindow getdata("Enter data",5.0,15.5,Position(23.0,0.0));
SimpleWindow entername("Enter  your Name Here:",23,15.5, Position(0,0));
SimpleWindow engame("Game Over",10,5, Position(5,5));

//Declaring all the windows that would be required

BitMap righttank(mainwindow);
BitMap lefttank(mainwindow);
BitMap background(mainwindow);
BitMap newgame(mainwindow);
BitMap settings(mainwindow);
BitMap instructions(instruct);
BitMap instruction(mainwindow);
BitMap highscore(mainwindow);
BitMap credits(mainwindow);
BitMap closes(mainwindow);
BitMap twoplayers(mainwindow);
BitMap targetpract(mainwindow);
BitMap returntomain(mainwindow);
BitMap levelselect(mainwindow);
BitMap back(mainwindow);
BitMap star(mainwindow);
BitMap bronze(mainwindow);
BitMap silver(mainwindow);
BitMap gold(mainwindow);
BitMap trophy(mainwindow);
BitMap selectlevel(mainwindow);
BitMap currentlevel1(mainwindow);
BitMap currentlevel2(mainwindow);
BitMap currentlevel3(mainwindow);
BitMap currentlevel4(mainwindow);
BitMap currentlevel5(mainwindow);
BitMap backbutton(mainwindow);
BitMap actualcredit(crdts);
BitMap closes2(instruct);
BitMap selectangle(getdata);
BitMap selectspeed(getdata);
BitMap selectweapon(getdata);
BitMap quarterl(getdata);
BitMap quarterr(getdata);
BitMap stline(getdata);
BitMap fire(getdata);
BitMap grazer(getdata);
BitMap threeshot(getdata);
BitMap grenade(getdata);
BitMap homing(getdata);
BitMap single(getdata);

char dummy[6]="dummy";
int lvel=1;
float xfinal;
float angll,anglr,angle;
float spdl,spdr,spd;
int weapon;//l,weaponr;
int check=0;
int scorel=0;
int scorer=0;
int lgf=0,ltf=0,lgdf=0,lhf=0,lsf=0;
int rgf=0,rtf=0,rgdf=0,rhf=0,rsf=0;
char pname1[50],pname2[50];
int temp=0,endgame=0;
//Declaring all the bitmap images to be  displayed in mainwindow

typedef struct
{
	char player_name[30];
	int player_score;
}player_data;

//Data type that stores player information

void drawmainmenu();
void drawnwgm();
void drwsttngs();
void drwnstrctns();
void drwrghttnk(float xcoord,int level);
void high(int endscore,char currplayer[30]);
void drwlfttnk(float xcoord,int level);
float hght(int lvl, float l);
void drawterrain(int level);
void drawstairs(int level);
int MouseClickEvent1(const Position &MousePosition1);
int MouseClickEvent2(const Position &MousePosition2);
int MouseClickEvent3(const Position &MousePosition3);
void wait ( int seconds );
void trajectory(int level, float theta, float u,int check);
void wgrazer(int level, float theta, float u,int check);
void wgrenade(int level, float theta, float u,int check);
void wthreeshot(int level, float theta, float u,int check);
void wsingleshot(int level, float theta, float u,int check);
void whoming(int level, float theta, float u,int check);
int MouseClickEvent4(const Position &p);
void drawgetdata();
void score(float xfinal,int check);
int MainwindowMouseClick(const Position &p);
void drawkeyboard();

//Prototype definition of functions to be defined and used ahead


char ss[50];
FILE *fp;
int kk=0;
BitMap a(entername);
BitMap b(entername);
BitMap c(entername);
BitMap d(entername);
BitMap e(entername);
BitMap f(entername);
BitMap gg(entername);
BitMap h(entername);
BitMap i(entername);
BitMap j(entername);
BitMap k(entername);
BitMap l(entername);
BitMap m(entername);
BitMap n(entername);
BitMap o(entername);
BitMap pp(entername);
BitMap q(entername);
BitMap r(entername);
BitMap s(entername);
BitMap t(entername);
BitMap u(entername);
BitMap v(entername);
BitMap w(entername);
BitMap x(entername);
BitMap y(entername);
BitMap z(entername);
BitMap space(entername);
BitMap backspace(entername);
BitMap enter(entername);

/////b c i 


void drawkeyboard()
{
	entername.Close();
	entername.Open();
  entername.RenderRectangle(Position(0,0),Position(50,50),Black);

  a.Load("a.xpm");
	assert(a.GetStatus() == BitMapOkay);
	a.SetPosition(Position(0,0));
	a.Draw();

b.Load("b.xpm");
assert(b.GetStatus() == BitMapOkay);
	b.SetPosition(Position(1.850,0.07));
	b.Draw();

c.Load("c.xpm");
assert(c.GetStatus() == BitMapOkay);
	c.SetPosition(Position(3.70,0));
	c.Draw();

d.Load("d.xpm");
assert(d.GetStatus() == BitMapOkay);
	d.SetPosition(Position(5.55,0));
	d.Draw();

e.Load("e.xpm");
assert(e.GetStatus() == BitMapOkay);
	e.SetPosition(Position(7.40,0));
	e.Draw();

f.Load("f.xpm");
assert(f.GetStatus() == BitMapOkay);
	f.SetPosition(Position(9.25,0));
	f.Draw();

gg.Load("g.xpm");
assert(gg.GetStatus() == BitMapOkay);
	gg.SetPosition(Position(11.1,0));
	gg.Draw();

h.Load("h.xpm");
assert(h.GetStatus() == BitMapOkay);
	h.SetPosition(Position(12.95,0));
	h.Draw();

i.Load("i.xpm");
assert(i.GetStatus() == BitMapOkay);
	i.SetPosition(Position(14.8,0));
	i.Draw();

j.Load("j.xpm");
assert(j.GetStatus() == BitMapOkay);
	j.SetPosition(Position(16.65,0));
	j.Draw();

k.Load("k.xpm");
assert(k.GetStatus() == BitMapOkay);
	k.SetPosition(Position(18.5,0));
	k.Draw();

l.Load("l.xpm");
assert(l.GetStatus() == BitMapOkay);
	l.SetPosition(Position(20.35,0));
	l.Draw();

m.Load("m.xpm");
assert(m.GetStatus() == BitMapOkay);
	m.SetPosition(Position(0,1.750));
	m.Draw();

n.Load("n.xpm");
assert(n.GetStatus() == BitMapOkay);
	n.SetPosition(Position(1.850,1.750));
	n.Draw();

o.Load("o.xpm");
assert(o.GetStatus() == BitMapOkay);
	o.SetPosition(Position(3.7,1.750));
	o.Draw();

pp.Load("p.xpm");
assert(pp.GetStatus() == BitMapOkay);
	pp.SetPosition(Position(5.550,1.750));
	pp.Draw();

q.Load("q.xpm");
assert(q.GetStatus() == BitMapOkay);
	q.SetPosition(Position(7.40,1.750));
	q.Draw();

r.Load("r.xpm");
assert(r.GetStatus() == BitMapOkay);
	r.SetPosition(Position(9.25,1.750));
	r.Draw();

s.Load("s.xpm");
assert(s.GetStatus() == BitMapOkay);
	s.SetPosition(Position(11.10,1.750));
	s.Draw();

t.Load("t.xpm");
assert(t.GetStatus() == BitMapOkay);
	t.SetPosition(Position(12.95,1.750));
	t.Draw();

u.Load("u.xpm");
assert(u.GetStatus() == BitMapOkay);
	u.SetPosition(Position(14.80,1.750));
	u.Draw();

v.Load("v.xpm");
assert(v.GetStatus() == BitMapOkay);
	v.SetPosition(Position(16.65,1.750));
	v.Draw();

w.Load("w.xpm");
assert(w.GetStatus() == BitMapOkay);
	w.SetPosition(Position(18.50,1.750));
	w.Draw();

x.Load("x.xpm");
assert(x.GetStatus() == BitMapOkay);
	x.SetPosition(Position(20.35,1.750));
	x.Draw();

y.Load("y.xpm");
assert(y.GetStatus() == BitMapOkay);
	y.SetPosition(Position(0,3.50));
	y.Draw();

z.Load("z.xpm");
assert(z.GetStatus() == BitMapOkay);
	z.SetPosition(Position(1.850,3.50));
	z.Draw();

space.Load("space.xpm");
assert(space.GetStatus() == BitMapOkay);
	space.SetPosition(Position(3.70,3.50));
	space.Draw();

backspace.Load("backspace.xpm");
assert(backspace.GetStatus() == BitMapOkay);
	backspace.SetPosition(Position(13.690,3.50));
	backspace.Draw();

enter.Load("enter.xpm");
assert(enter.GetStatus() == BitMapOkay);
	enter.SetPosition(Position(15.550,3.50));
	enter.Draw();
//entername.RenderText(Position(0.0,7),Position(22,9),ss,Red,White);
entername.SetMouseClickCallback(MainwindowMouseClick);
}



int MainwindowMouseClick(const Position &p)
{
char name;
if(a.IsInside(p))
{
	name='a';
	ss[kk]=name;
	ss[kk+1]='\0';
	kk++;
}
if(b.IsInside(p))
{
	name='b';
	ss[kk]=name;
	ss[kk+1]='\0';
	kk++;
}
if(c.IsInside(p))
{
	name='c';
	ss[kk]=name;
	ss[kk+1]='\0';
	kk++;
}
if(d.IsInside(p))
{
	name='d';
	ss[kk]=name;
	ss[kk+1]='\0';
	kk++;
}
if(e.IsInside(p))
{
	name='e';
	ss[kk]=name;
	ss[kk+1]='\0';
	kk++;
}
if(f.IsInside(p))
{
	name='f';
	ss[kk]=name;
	ss[kk+1]='\0';
	kk++;
}
if(gg.IsInside(p))
{
	name='g';
	ss[kk]=name;
	ss[kk+1]='\0';
	kk++;
}
if(h.IsInside(p))
{
	name='h';
	ss[kk]=name;
	ss[kk+1]='\0';
	kk++;
}
if(i.IsInside(p))
{
	name='i';
	ss[kk]=name;
	ss[kk+1]='\0';
	kk++;
}
if(j.IsInside(p))
{
	name='j';
	ss[kk]=name;
	ss[kk+1]='\0';
	kk++;
}
if(k.IsInside(p))
{
	name='k';
	ss[kk]=name;
	ss[kk+1]='\0';
	kk++;
}
if(l.IsInside(p))
{
	name='l';
	ss[kk]=name;
	ss[kk+1]='\0';
	kk++;
}
if(m.IsInside(p))
{
	name='m';
	ss[kk]=name;
	ss[kk+1]='\0';
	kk++;
}
if(n.IsInside(p))
{
	name='n';
	ss[kk]=name;
	ss[kk+1]='\0';
	kk++;
}
if(o.IsInside(p))
{
	name='o';
	ss[kk]=name;
	ss[kk+1]='\0';
	kk++;
}
if(pp.IsInside(p))
{
	name='p';
	ss[kk]=name;
	ss[kk+1]='\0';
	kk++;
}
if(q.IsInside(p))
{
	name='q';
	ss[kk]=name;
	ss[kk+1]='\0';
	kk++;
}
if(r.IsInside(p))
{
	name='r';
	ss[kk]=name;
	ss[kk+1]='\0';
	kk++;
}
if(s.IsInside(p))
{
	name='s';
	ss[kk]=name;
	ss[kk+1]='\0';
	kk++;
}
if(t.IsInside(p))
{
	name='t';
	ss[kk]=name;
	ss[kk+1]='\0';
	kk++;
}
if(u.IsInside(p))
{
	name='u';
	ss[kk]=name;
	ss[kk+1]='\0';
	kk++;
}
if(v.IsInside(p))
{
	name='v';
	ss[kk]=name;
	ss[kk+1]='\0';
	kk++;
}
if(w.IsInside(p))
{
	name='w';
	ss[kk]=name;
	ss[kk+1]='\0';
	kk++;
}
if(x.IsInside(p))
{
	name='x';
	ss[kk]=name;
	ss[kk+1]='\0';
	kk++;
}
if(y.IsInside(p))
{
	name='y';
	ss[kk]=name;
	ss[kk+1]='\0';
	kk++;
}
if(z.IsInside(p))
{
	name='z';
	ss[kk]=name;
	ss[kk+1]='\0';
	kk++;
}
if(space.IsInside(p))
{
	name=' ';
	ss[kk]=name;
	ss[kk+1]='\0';
	kk++;
}
if(backspace.IsInside(p) && kk>0)
{
	ss[kk-1]='\0';
	kk--;
	entername.RenderText(Position(0.0,7),Position(22,9),"                                                         ",Black,Black);
	entername.RenderText(Position(0.0,7),Position(22,9),ss,White,Black);
}

entername.RenderText(Position(0.0,7),Position(22,9),ss,White,Black);

if(enter.IsInside(p))
{
	
	if(temp==0){
	strcpy(pname1,ss);
	drawkeyboard();
	temp++;
	kk=0;
	for(int xsd=0;xsd<50;xsd++)
	{
		ss[xsd]='\0';
	}
	}
	else
	{
	strcpy(pname2,ss);
	entername.Close();
	}
}

return 0;

}


void drawmainmenu()
{
	mainwindow.Open();
    	
	background.Load("background.xpm");
	assert(background.GetStatus() == BitMapOkay);
	background.SetPosition(Position(0.0, 0.0));
	background.Draw();
        
	newgame.Load("newgamepatch.xpm");
	assert(newgame.GetStatus() == BitMapOkay);
	newgame.SetPosition(Position(13.6, 5.0));
	newgame.Draw();
	
	settings.Load("settingspatch.xpm");
	assert(settings.GetStatus() == BitMapOkay);
	settings.SetPosition(Position(13.875, 7.0));
	settings.Draw();
        
    	instruction.Load("instructionspatch.xpm");
	assert(instruction.GetStatus() == BitMapOkay );
	instruction.SetPosition(Position(13.4 , 9.0));
	instruction.Draw();

   	highscore.Load("highscorespatch.xpm");
	assert(highscore.GetStatus() == BitMapOkay);
	highscore.SetPosition(Position(13.425, 11.0));
	highscore.Draw();

	credits.Load("creditspatch.xpm");
	assert(credits.GetStatus() == BitMapOkay);
	credits.SetPosition(Position(14.0, 13.0));
	credits.Draw();
        
    	closes.Load("close.xpm");
	assert(closes.GetStatus() == BitMapOkay);
	closes.SetPosition(Position(21.0, 13.00));
	closes.Draw();

	mainwindow.SetMouseClickCallback(MouseClickEvent1);
}
//Function that draws the Mainmenu

void drawnwgm()
{
	
	mainwindow.Close();
	mainwindow.Open();
	//newgame.Erase();	
	//settings.Erase();
	//highscore.Erase();
	//instruction.Erase();
    	//credits.Erase(); 
    	
	background.Load("background.xpm");
	assert(background.GetStatus() == BitMapOkay);
	background.SetPosition(Position(0.0, 0.0));
	background.Draw();    
	  
    	twoplayers.Load("twoplayer.xpm");
	assert(twoplayers.GetStatus() == BitMapOkay);
    	twoplayers.SetPosition(Position(14.49, 5.0));	     
    	twoplayers.Draw();
        
		
    	targetpract.Load("targetpractice.xpm");
	assert(targetpract.GetStatus() == BitMapOkay);
    	targetpract.SetPosition(Position(13.87, 7.0));
    	targetpract.Draw();		

    	returntomain.Load("returntomain.xpm");
	assert(returntomain.GetStatus() == BitMapOkay);
    	returntomain.SetPosition(Position(13.25, 9.0));
    	returntomain.Draw();
	mainwindow.SetMouseClickCallback(MouseClickEvent2);
		
}
//Function that draws the screen for Click on "New Game" Button

	
void drwnstrctns()
{
	instruct.Open();
	instructions.Load("instructions.xpm");
	assert(instructions.GetStatus() == BitMapOkay);
	instructions.SetPosition(Position(0.0, 0.0));	     
    	instructions.Draw();

}
//Displays a window in which instructions are displayed

int powerten(int x)
{
	int i,value=1;
	for(i=0;i<x;i++)
	{
		value=value*10;
	}
	return value;
}
void reverse_string(char str[])
{
    char c;
    char *p, *q;

    p = str;
    if (!p)
        return;

    q = p + 1;
    if (*q == '\0')
        return;

    c = *p;
    reverse_string(q);

    while (*q != '\0') 
    {
        *p = *q;
        p++;
        q++;
    }
    *p = c;

    return;
}
void high(int endscore,char currplayer[30])
{
	FILE *pointer,*out;
	int actualscore[5],i,j,l,jfinal,jprev,count,length[5],tempscore,b;
	char inputline[50],plname[30];
	string fordisplay;
	player_data a[5],current,temp;
	pointer=fopen("highscores.txt","r+");
	if(pointer==NULL)
	{
		cout<<"HIGH SCORES Input file error !!!";
	}
	else
	{
		for(i=0;i<5;i++)
		{
			jprev=0;
			jfinal=0;
			count=0;
			tempscore=0;
			fgets(inputline,50,pointer);
			length[i]=strlen(inputline);
			for(j=0;inputline[j]!='\n';j++)
			{
				if(inputline[j]==',')
				{
					jfinal=j;
					for(l=0;l<jfinal;l++)
					{
						plname[l]=inputline[l];
					}
					plname[jfinal-jprev+1]='\0';
					if(plname[0]>=97 && plname[0]<=122)
					{
						plname[0]=plname[0]-32;
					}
				}
				jprev=jfinal+1;
				int sz=sizeof(plname);
				for(l=0;l<sz;l++)
				{
					a[i].player_name[l]=plname[l];
				}
			}
			for(l=0;l<5;l++)
			{
				actualscore[l]=0;
			}
			for(l=(length[i]-2),b=4;l>jfinal;b--,l--)
			{
				actualscore[b]=inputline[l]-48;
			}
			for(l=0;l<5;l++)
			{
				tempscore+=(actualscore[l])*(powerten(4-l));
			}
			a[i].player_score=tempscore;
		}
	}
	for(i=0;i<5;i++)
	{
		for(j=i+1;j<5;j++)
		{
			if(a[i].player_score<a[j].player_score)
			{
				temp=a[i];
				a[i]=a[j];
				a[j]=temp;
			}
		}
	}
	if(endscore>a[4].player_score)
	{
		if(currplayer[0]>=97 && currplayer[0]<=122)
		{
			currplayer[0]=currplayer[0]-32;
		}
		int big=(sizeof(a[4].player_name)>sizeof(currplayer))? sizeof(a[4].player_name):sizeof(currplayer);
		for(i=0;i<=big;i++)
		{
			a[4].player_name[i]=currplayer[i];
		}
		a[4].player_score=endscore;
	}
	for(i=0;i<5;i++)
	{
		for(j=i+1;j<5;j++)
		{
			if(a[i].player_score<a[j].player_score)
			{
				temp=a[i];
				a[i]=a[j];
				a[j]=temp;
			}
		}
	}
	out=fopen("temporary.txt","w");
	for(i=0;i<5;i++)
	{
		fprintf(out,"%s,%d",a[i].player_name,a[i].player_score);
		fputc('\n',out);
	}
	highscores.Open();
	for(i=0;i<5;i++)
	{
		char score[10];
		int count=0;
		for(j=0;a[i].player_score!=0;j++)
		{
			count++;
			score[j]=(a[i].player_score%10)+48;
			a[i].player_score=a[i].player_score/10;
		}
		score[count]='\0';
		reverse_string(score);
		highscores.RenderText(Position(0.1,(1.5+i)),Position(7.0,(2.4+i)),a[i].player_name,Red,White);
		highscores.RenderText(Position(7.0,(1.5+i)),Position(8.0,(2.4+i)),"  ",Black,White);
		highscores.RenderText(Position(8.0,(1.5+i)),Position(10.0,(2.4+i)),score,Red,White);

	}
	fclose(pointer);
	fclose(out);
	remove("highscores.txt");
	rename("temporary.txt","highscores.txt");
}
//Function that takes input from a file called "highscores.txt", checks if the current score qualifies
//for being included in the list, and then arranges the scores in descending order with the names 
//of the corresponding players against them(initial letter capital)

void drawcredits()
{
	crdts.Open();
	actualcredit.Load("credits.xpm");
	assert(actualcredit.GetStatus()==BitMapOkay);
	Position PhotoPosition= Position (0.0,0.0);
	actualcredit.SetPosition(PhotoPosition);
	actualcredit.Draw();
	//sleep(5);
	//crdts.Close();
}
//Function that opens a new window, displays credits for 5 seconds, then closes the window


void drwrghttnk(float xcoord,int level)
{
	righttank.Load("right tank.xpm");
	assert(righttank.GetStatus()==BitMapOkay);
	Position PhotoPosition=Position (xcoord,15.2-hght(level,xcoord));
	righttank.SetPosition(PhotoPosition);
	righttank.Draw();
}
// Function that draws the right tank at a specified x-coordinate as input


void drwlfttnk(float xcoord,int level)
{
	lefttank.Load("left tank.xpm");
	assert(lefttank.GetStatus()==BitMapOkay);
	Position PhotoPosition=Position (xcoord,15.2-hght(level,xcoord));
	lefttank.SetPosition(PhotoPosition);
	lefttank.Draw();
}
// Function that draws the left tank taking a specified x-coordinate as input


float hght(int lvl, float l)
{
	if(lvl==1)
	{
		float height=5;	
		return height;
	}
	if(lvl==2) 
	{
		
		float height = 12.0 - 0.85*exp(l*2/20) ;
		return height;
	}
	if(lvl==3)
	{
		
		//float const Pi=3.141;
		float height = 5+(atan (-25+(l*50/20))) * 4/ Pi;
		return height;
	}
	if(lvl==4)
	{
		
		//float const Pi=3.141;
		float arg=((Pi/2)+((Pi/20)*(l+0.005)));
		float height=(5*(sin(arg)*sin(arg)));
		return height;
	}
	if(lvl==5)
	{
		
		//float const Pi=3.141;
		float arg=((-1.5*Pi)+((l+0.005)*Pi*0.15));
		float amp=(5-(abs((l+0.005)-5)));
		float height=(abs((amp)*(cos(arg)*cos(arg))))+1;
		return height;
	}
}	
//Function that defines height for a terrain according to the level

void drawterrain(int level)
{
if(endgame<10)
{
if (level==1)
{
mainwindow.Close();
mainwindow.Open();
assert(mainwindow.GetStatus() == WindowOpen);
float i;
for(i=0;i<(windowlength);i+=0.01)
{
		mainwindow.RenderLine(Position((i+0.005),windowheight),Position((i+0.005),(windowheight-hght(level,i))),Green,thck);
		mainwindow.RenderLine(Position((i+0.005),0),Position((i+0.005),(windowheight-hght(level,i))),Blue,thck);
}
}
else if(level==2)
{
mainwindow.Open();
assert(mainwindow.GetStatus() == WindowOpen);
float i;
for(i=0;i<(windowlength);i+=0.01)
{
		mainwindow.RenderLine(Position((i+0.005),windowheight),Position((i+0.005),(windowheight-hght(level,i))),Green,thck);
		mainwindow.RenderLine(Position((i+0.005),0),Position((i+0.005),(windowheight-hght(level,i))),Blue,thck);
}
}
else if (level==3)
{
mainwindow.Open();
assert(mainwindow.GetStatus() == WindowOpen);
float i;
for(i=0;i<(windowlength);i+=0.01)
{
		mainwindow.RenderLine(Position((i+0.005),windowheight),Position((i+0.005),(windowheight-hght(level,i))),Green,thck);
		mainwindow.RenderLine(Position((i+0.005),0),Position((i+0.005),(windowheight-hght(level,i))),Blue,thck);
}
}
else if(level==4)
{
mainwindow.Open();
assert(mainwindow.GetStatus() == WindowOpen);
float i;
for(i=0;i<(windowlength);i+=0.01)
{
		mainwindow.RenderLine(Position((i+0.005),windowheight),Position((i+0.005),(windowheight-hght(level,i))),Green,thck);
		mainwindow.RenderLine(Position((i+0.005),0),Position((i+0.005),(windowheight-hght(level,i))),Blue,thck);
}
}
else if(level==5)
{
mainwindow.Open();
assert(mainwindow.GetStatus() == WindowOpen);
float i;
for(i=0;i<(windowlength);i+=0.01)
{
		mainwindow.RenderLine(Position((i+0.005),windowheight),Position((i+0.005),(windowheight-hght(level,i))),Green,thck);
		mainwindow.RenderLine(Position((i+0.005),0),Position((i+0.005),(windowheight-hght(level,i))),Blue,thck);
}
}
score(xfinal,check);
}
else
{
getdata.Close();
mainwindow.Close();
drawmainmenu();
mainwindow.Close();
drawmainmenu();
int winner=(scorer>=scorel)?1:2;
if(winner==1)
{
	engame.Open();
	engame.RenderText(Position(0.0,0.0),Position(5.0,5.0),pname2,Red,Black);
	engame.RenderText(Position(5.0,0.0),Position(10.0,5.0)," Wins !!!",Red,Black);
	engame.RenderText(Position(5.0,0.0),Position(10.0,5.0)," Wins !!!",Red,Black);
	sleep(5);
	high(scorer,pname2);
}
if(winner==2)
{
	engame.Open();
	engame.RenderText(Position(0.0,0.0),Position(5.0,5.0),pname1,Red,Black);
	engame.RenderText(Position(5.0,0.0),Position(10.0,5.0)," Wins !!!",Red,Black);
	engame.RenderText(Position(5.0,0.0),Position(10.0,5.0)," Wins !!!",Red,Black);
	sleep(5);
	high(scorel,pname1);
}


endgame=0;
}
}
//Function that takes level as input and generates terrains using functions defined above

void drawstairs(int level)
{
	mainwindow.Close();
	mainwindow.Open();
	
	mainwindow.RenderLine(Position(0.0,15.5),Position(2.0,15.5),Black,0.2);
	RectangleShape r1(mainwindow,3,14.5,Black,2.0,2.0);
	r1.Draw();
	RectangleShape r2(mainwindow,5,13.5,Black,2,4);
	r2.Draw();
	RectangleShape r3(mainwindow,7,12.5,Black,2,6);
	r3.Draw();
	RectangleShape r4(mainwindow,9,11.5,Black,2.0,8);
	r4.Draw();
	RectangleShape r5(mainwindow,11,10.5,Black,2.0,10);
	r5.Draw();
	
	star.Load("star.xpm");
	assert(star.GetStatus() == BitMapOkay);
	star.SetPosition(Position(2, 11.5));	     
   	star.Draw();

	bronze.Load("bronze.xpm");
	assert(bronze.GetStatus() == BitMapOkay);
	bronze.SetPosition(Position(4, 9.5));	     
    	bronze.Draw();

	silver.Load("silver.xpm");
	assert(silver.GetStatus() == BitMapOkay);
	silver.SetPosition(Position(6, 7.5));	     
    	silver.Draw();

	gold.Load("gold.xpm");
	assert(gold.GetStatus() == BitMapOkay);
	gold.SetPosition(Position(8, 5.5));	     
    	gold.Draw();

	trophy.Load("trophy.xpm");
	assert(trophy.GetStatus() == BitMapOkay);
	trophy.SetPosition(Position(10, 3.5));	     
    	trophy.Draw();

	backbutton.Load("backbutton.xpm");
	assert(backbutton.GetStatus() == BitMapOkay);
	backbutton.SetPosition(Position(13, 12.75));	     
    	backbutton.Draw();

	selectlevel.Load("selectlevelpatch.xpm");
	assert(selectlevel.GetStatus() == BitMapOkay);
	selectlevel.SetPosition(Position(1.0, 1.0));	     
    	selectlevel.Draw();

	currentlevel1.Load("currentlevel1.xpm");
	assert(currentlevel1.GetStatus()== BitMapOkay);
	currentlevel1.SetPosition(Position(1.0,3.0));
	
	currentlevel2.Load("currentlevel2.xpm");
	assert(currentlevel2.GetStatus()== BitMapOkay);
	currentlevel2.SetPosition(Position(1.0,3.0));

	currentlevel3.Load("currentlevel3.xpm");
	assert(currentlevel3.GetStatus()== BitMapOkay);
	currentlevel3.SetPosition(Position(1.0,3.0));

	currentlevel4.Load("currentlevel4.xpm");
	assert(currentlevel4.GetStatus()== BitMapOkay);
	currentlevel4.SetPosition(Position(1.0,3.0));

	currentlevel5.Load("currentlevel5.xpm");
	assert(currentlevel5.GetStatus()== BitMapOkay);
	currentlevel5.SetPosition(Position(1.0,3.0));
	
	switch(level)
	{
	case 1:
		currentlevel2.Erase();
		currentlevel3.Erase();
		currentlevel4.Erase();
		currentlevel5.Erase();
		currentlevel1.Draw();
		break;
	case 2:
		currentlevel1.Erase();
		currentlevel3.Erase();
		currentlevel4.Erase();
		currentlevel5.Erase();
		currentlevel2.Draw();
		break;
	case 3:
		currentlevel1.Erase();
		currentlevel2.Erase();
		currentlevel4.Erase();
		currentlevel5.Erase();
		currentlevel3.Draw();
		break;
	case 4:
		currentlevel1.Erase();
		currentlevel2.Erase();
		currentlevel3.Erase();
		currentlevel5.Erase();
		currentlevel4.Draw();
		break;
	case 5:
		currentlevel1.Erase();
		currentlevel2.Erase();
		currentlevel3.Erase();
		currentlevel4.Erase();
		currentlevel5.Draw();
		break;
	default:
		currentlevel2.Erase();
		currentlevel3.Erase();
		currentlevel4.Erase();
		currentlevel5.Erase();
		currentlevel1.Draw();
		break;
	}
	mainwindow.SetMouseClickCallback(MouseClickEvent3);
}
//Function that draws the screen for taking input of level when clicked on the settings tab

int MouseClickEvent1(const Position &MousePosition1)
{
	if(newgame.IsInside(MousePosition1))
	{
		drawnwgm();
	}

    	if(settings.IsInside(MousePosition1))
	{
		drawstairs(1);	
    	}
        
	if(instruction.IsInside(MousePosition1))
	{
		drwnstrctns();
	}

	if(highscore.IsInside(MousePosition1))
	{
		high(0,dummy);
	}

	if(credits.IsInside(MousePosition1))
	{
		drawcredits();
	}
	if(closes.IsInside(MousePosition1))
	{
		mainwindow.Close();
	}

}

int MouseClickEvent2(const Position &MousePosition2)
{
	if(twoplayers.IsInside(MousePosition2))
	{
		mainwindow.Close();
		mainwindow.Open();
		drawgetdata();
		drawterrain(lvel);
		drwlfttnk(lftdflt,lvel);
		drwrghttnk(rghtdflt,lvel);
		drwrghttnk(rghtdflt,lvel);
	}

    	if(targetpract.IsInside(MousePosition2))
	{
		drawnwgm();
    	}
        
	if(returntomain.IsInside(MousePosition2))
	{
		drawmainmenu();
	}
}

int MouseClickEvent3(const Position &MousePosition3)
{
	int level;
	if(star.IsInside(MousePosition3))
	{
		level=1;
		lvel=level;
		drawstairs(level);
	}

    	if(bronze.IsInside(MousePosition3))
	{
		level=2;
		lvel=level;
		drawstairs(level);	
    	}
        
	if(silver.IsInside(MousePosition3))
	{
		level=3;
		lvel=level;
		drawstairs(level);
	}
	
	if(gold.IsInside(MousePosition3))
	{
		level=4;
		lvel=level;
		drawstairs(level);
	}
	
	if(trophy.IsInside(MousePosition3))
	{
		level=5;
		lvel=level;
		drawstairs(level);
	}

	if(backbutton.IsInside(MousePosition3))
	{
		mainwindow.Close();
		mainwindow.Open();		
		drawmainmenu();
	}
	//cout<<"lvel is "<<lvel<<endl;
}

void wait ( int seconds )
{
  clock_t endwait;
  endwait = clock () + seconds * CLOCKS_PER_SEC/100;
  while (clock() < endwait) {}
}

void trajectory(int level, float theta, float u,int check){

if (check==0){
	theta=theta*Pi/180;

	float x, y, y2=0, y3=0,x2=lftdflt,x3=lftdflt;	

	for( x=lftdflt;x<25.5; x+= diff){

	float h =15.5-hght(level,x);
	y = 15.5-hght(level,lftdflt) - 0.01 - (x-lftdflt)*tan(theta) + (g*(x-lftdflt)*(x-lftdflt))/(2*u*u*cos(theta)* cos(theta) );
	mainwindow.RenderEllipse(Position (x-0.1, y-0.1),Position (x+0.1, y+0.1),Red, false); 
	
	usleep(1000);
	mainwindow.RenderEllipse(Position (x2-0.25, y2-0.25),Position (x2+0.25, y2+0.25),Green, false);
	
	usleep(1000);
	mainwindow.RenderEllipse(Position (x3-0.25, y3-0.25),Position (x3+0.25, y3+0.25),Blue, false);
	usleep(1000);
	if(y>=h){
		break;
	}
	else if(y<h){
		x2=x;
		x3=x2;
		y2=y;
		y3=y2;
	}
}
xfinal = x;
}

if (check==1){
	theta=theta*Pi/180;

	float x, y, y2=0, y3=0,x2=rghtdflt,x3=rghtdflt;	

	for( x=rghtdflt;x>-5; x-= diff){

	float h =15.5-hght(level,x);
	y = 15.5-hght(level,lftdflt) - 0.01 - (rghtdflt-x)*tan(theta) + (g*(rghtdflt-x)*(rghtdflt-x))/(2*u*u*cos(theta)* cos(theta) );
	mainwindow.RenderEllipse(Position (x-0.1, y-0.1),Position (x+0.1, y+0.1),Red, false); 

	usleep(1000);
	mainwindow.RenderEllipse(Position (x2-0.25, y2-0.25),Position (x2+0.25, y2+0.25),Green, false);
	
	usleep(1000);
	mainwindow.RenderEllipse(Position (x3-0.25, y3-0.25),Position (x3+0.25, y3+0.25),Blue, false);
	usleep(1000);
	if(y>=h){
		break;
	}
	else if(y<h){
		x2=x;
		x3=x2;
		y2=y;
		y3=y2;
	}
}
xfinal = x;
}
}

void wgrazer(int level, float theta, float u,int check){
	//drawterrain(level);
	//drawtank(0.0,level);
xfinal=100;	

	float k2,k3,m2,m3;
	float k=xfinal;
	k2=k;
	k3=k;
	float m= hght(level,lftdflt) - 0.01 - xfinal*tan(theta) + (g*xfinal*xfinal)/(2*u*u*cos(theta)* cos(theta) );
	m2=m;
	m3=m;
	float limit;
if(check==0){
	if(lgf>0)
	{ levelerror.Open();
	levelerror.RenderText(Position(0.0,0.0),Position(10.0,5.0),"Player 1:You can use the weapon only once !!!",Black,White);
	levelerror.RenderText(Position(0.0,0.0),Position(10.0,5.0),"Player 1:You can use the weapon only once !!!",Black,White);
	sleep(2);
	levelerror.Close();
		return;
	}

	if(lgf==0)
	{
	endgame++;	
	lgf++;
	trajectory(level,theta,u,check);
	if(xfinal>rghtdflt) limit=25.5;
	if(xfinal<rghtdflt) limit=rghtdflt;
	for(k=xfinal; k<=limit; k+= diff)
	{
		m= 15.5-hght(level,k);
	
		mainwindow.RenderEllipse(Position (k-0.1, m-0.1),Position (k+0.1, m+0.1),Red, false); //(color)i, 2);
		usleep(1000);
		mainwindow.RenderEllipse(Position (k2-0.25, m2-0.25),Position (k2+0.25, m2+0.25),Green, false);
		usleep(1000);
		mainwindow.RenderEllipse(Position (k3-0.25, m3-0.25),Position (k3+0.25, m3+0.25),Blue, false);
		usleep(1000);
		k2=k;
		k3=k2;
		m2=m;
		m3=m2;
	}
	xfinal=k;
	//score(xfinal,check);
	}

}

else if(check==1){
	if(rgf==0)
	{
	endgame++;
	rgf++;
	trajectory(level,theta,u,check);
	if(xfinal<lftdflt) limit=-5;
	if(xfinal>lftdflt) limit=lftdflt;
	for(k=xfinal; k>=limit; k-= diff)
	{
		m= 15.5-hght(level,k);
	
		mainwindow.RenderEllipse(Position (k-0.1, m-0.1),Position (k+0.1, m+0.1),Red, false); //(color)i, 2);
		usleep(1000);
		mainwindow.RenderEllipse(Position (k2-0.25, m2-0.25),Position (k2+0.25, m2+0.25),Green, false);
		usleep(1000);
		mainwindow.RenderEllipse(Position (k3-0.25, m3-0.25),Position (k3+0.25, m3+0.25),Blue, false);
		usleep(1000);
		k2=k;
		k3=k2;
		m2=m;
		m3=m2;
	}
	xfinal=k;
	//score(xfinal,check);
	//rgf++;
	}
	else {
	levelerror.Open();
	levelerror.RenderText(Position(0.0,0.0),Position(10.0,5.0),"Player 2:You can use the weapon only once !!!",Black,White);
	levelerror.RenderText(Position(0.0,0.0),Position(10.0,5.0),"Player 2:You can use the weapon only once !!!",Black,White);
	sleep(2);
	levelerror.Close();		
	}


}
//rgf++;
//lgf++;
}

void wthreeshot(int level,float theta,float u,int check){
xfinal=100;
if (check==1){
	if(rtf==0){
	endgame++;
	rtf++;
float x,x1,y[6];
int flag[3]={1,1,1};
float theta1,theta2,u1=u+2,u2=u-2;
float xfinal1,xfinal2,xfinal3;
theta=theta*Pi/180;
theta2=theta-0.04 ;
theta1=theta+0.025 ;


  for( x=rghtdflt;x>-5;x-=diff)
{
x1=x+1;
 y[0] = 15.5-hght(level,rghtdflt) - 0.01 - (rghtdflt-x)*tan(theta) + (g*(rghtdflt-x)*(rghtdflt-x))/(2*u*u*cos(theta)* cos(theta) ); 
if(flag[0]!=0) 
if(y[0]<(15.5-hght(level,x)))
    mainwindow.RenderEllipse (Position(x-(radius),y[0]-(radius)),Position(x+(radius),y[0]+(radius)),Red,false) ;
    
else
  flag[0]=0; 
/*temp=y[0];
temp1=15.5-hght(level,x);
 cout<<temp<<endl<<temp1<<endl;
*/y[1] = 15.5-hght(level,rghtdflt) - 0.01 - (rghtdflt-x)*tan(theta1) + (g*(rghtdflt-x)*(rghtdflt-x))/(2*u1*u1*cos(theta1)* cos(theta1) ); 

if(flag[1]!=0)
 if(y[1]<(15.5-hght(level,x)))
   mainwindow.RenderEllipse (Position(x-(radius),y[1]-(radius)),Position(x+(radius),y[1]+(radius)),Red,false) ;
else
 flag[1]=0; 
   
 y[2] = 15.5-hght(level,rghtdflt) - 0.01 - (rghtdflt-x)*tan(theta2) + (g*(rghtdflt-x)*(rghtdflt-x))/(2*u2*u2*cos(theta2)* cos(theta2) );  

if(flag[2]!=0)
 if(y[2]<(15.5-hght(level,x)))
    mainwindow.RenderEllipse (Position(x-(radius),y[2]-(radius)),Position(x+(radius),y[2]+(radius)),Red,false) ;
  else
 flag[2]=0; 
 
  

y[3] = 15.5-hght(level,rghtdflt) - 0.01 - (rghtdflt-x1)*tan(theta) + (g*(rghtdflt-x1)*(rghtdflt-x1))/(2*u*u*cos(theta)* cos(theta) );


   if(y[3]<(15.5-hght(level,x1)))
{
  mainwindow.RenderEllipse (Position(x1-(radius),y[3]-(radius)),Position(x1+(radius),y[3]+(radius)),Blue,false) ;
xfinal1=x1;
}

y[4] = 15.5-hght(level,rghtdflt) - 0.01 - (rghtdflt-x1)*tan(theta1) + (g*(rghtdflt-x1)*(rghtdflt-x1))/(2*u1*u1*cos(theta1)* cos(theta1) );


 if(y[4]<(15.5-hght(level,x1)))
{ 
   mainwindow.RenderEllipse (Position(x1-(radius),y[4]-(radius)),Position(x1+(radius),y[4]+(radius)),Blue,false) ;
xfinal2=x1;
}

y[5] = 15.5-hght(level,rghtdflt) - 0.01 - (rghtdflt-x1)*tan(theta2) + (g*(rghtdflt-x1)*(rghtdflt-x1))/(2*u2*u2*cos(theta2)* cos(theta2) );


  if(y[5]<(15.5-hght(level,x1)))
{
   mainwindow.RenderEllipse (Position(x1-(radius),y[5]-(radius)),Position(x1+(radius),y[5]+(radius)),Blue,false) ;
   xfinal3=x1;
}

 usleep(1000);
}
float diff1,diff2,diff3;
diff1=abs(xfinal1-lftdflt);
diff2=abs(xfinal2-lftdflt);
diff3=abs(xfinal3-lftdflt);
xfinal=(diff1<diff2)?xfinal1:xfinal2;
xfinal=(xfinal<diff3)?xfinal:xfinal3;
//cout<<xfinal<<endl;
//score(xfinal,check);
}

else{
	levelerror.Open();
	levelerror.RenderText(Position(0.0,0.0),Position(10.0,5.0),"Player 2:You can use the weapon only once !!!",Black,White);
	levelerror.RenderText(Position(0.0,0.0),Position(10.0,5.0),"Player 2:You can use the weapon only once !!!",Black,White);
	sleep(2);
	levelerror.Close();

}

}

if (check==0){
	if(ltf==0){
	endgame++;
	ltf++;
	
float x,x1,y[6];
int flag[3]={1,1,1};

float theta1,theta2,u1=u+3,u2=u-3;
float xfinal1,xfinal2,xfinal3;
theta=theta*Pi/180;
theta2=theta-0.04 ;
theta1=theta+0.025 ;


  for( x=lftdflt;x<25;x+=diff)
{
x1=x-1;
 y[0] = 15.5-hght(level,lftdflt) - 0.01 - (x-lftdflt)*tan(theta) + (g*(x-lftdflt)*(x-lftdflt))/(2*u*u*cos(theta)* cos(theta) ); 
if(flag[0]!=0) 
if(y[0]<(15.5-hght(level,x)))
    mainwindow.RenderEllipse (Position(x-(radius),y[0]-(radius)),Position(x+(radius),y[0]+(radius)),Red,false) ;
    
else
  flag[0]=0; 
/*temp=y[0];
temp1=15.5-hght(level,x);
 cout<<temp<<endl<<temp1<<endl;
*/y[1] = 15.5-hght(level,rghtdflt) - 0.01 - (x-lftdflt)*tan(theta1) + (g*(x-lftdflt)*(x-lftdflt))/(2*u1*u1*cos(theta1)* cos(theta1) ); 

if(flag[1]!=0)
 if(y[1]<(15.5-hght(level,x)))
   mainwindow.RenderEllipse (Position(x-(radius),y[1]-(radius)),Position(x+(radius),y[1]+(radius)),Red,false) ;
else
 flag[1]=0; 
   
 y[2] = 15.5-hght(level,rghtdflt) - 0.01 - (x-lftdflt)*tan(theta2) + (g*(x-lftdflt)*(x-lftdflt))/(2*u2*u2*cos(theta2)* cos(theta2) );  

if(flag[2]!=0)
 if(y[2]<(15.5-hght(level,x)))
    mainwindow.RenderEllipse (Position(x-(radius),y[2]-(radius)),Position(x+(radius),y[2]+(radius)),Red,false) ;
  else
 flag[2]=0; 
 
  

y[3] = 15.5-hght(level,rghtdflt) - 0.01 - (x1-lftdflt)*tan(theta) + (g*(x1-lftdflt)*(x1-lftdflt))/(2*u*u*cos(theta)* cos(theta) );


   if(y[3]<(15.5-hght(level,x1)))
{
  mainwindow.RenderEllipse (Position(x1-(radius),y[3]-(radius)),Position(x1+(radius),y[3]+(radius)),Blue,false) ;
   xfinal1=x1;
}

y[4] = 15.5-hght(level,rghtdflt) - 0.01 - (x1-lftdflt)*tan(theta1) + (g*(x1-lftdflt)*(x1-lftdflt))/(2*u1*u1*cos(theta1)* cos(theta1) );


 if(y[4]<(15.5-hght(level,x1)))
{ 
   mainwindow.RenderEllipse (Position(x1-(radius),y[4]-(radius)),Position(x1+(radius),y[4]+(radius)),Blue,false) ;
   xfinal2=x1;
}

y[5] = 15.5-hght(level,rghtdflt) - 0.01 - (x1-lftdflt)*tan(theta2) + (g*(x1-lftdflt)*(x1-lftdflt))/(2*u2*u2*cos(theta2)* cos(theta2) );


  if(y[5]<(15.5-hght(level,x1)))
{
   mainwindow.RenderEllipse (Position(x1-(radius),y[5]-(radius)),Position(x1+(radius),y[5]+(radius)),Blue,false) ;
   xfinal3=x1;
}

 usleep(1000);
}
float diff1,diff2,diff3;
diff1=abs(xfinal1-rghtdflt);
diff2=abs(xfinal2-rghtdflt);
diff3=abs(xfinal3-rghtdflt);
xfinal=(diff1<diff2)?xfinal1:xfinal2;
xfinal=(xfinal<diff3)?xfinal:xfinal3;
//cout<<xfinal<<endl;
//score(xfinal,check);
}
else{
	levelerror.Open();
	levelerror.RenderText(Position(0.0,0.0),Position(10.0,5.0),"Player 1:You can use the weapon only once !!!",Black,White);
	levelerror.RenderText(Position(0.0,0.0),Position(10.0,5.0),"Player 1:You can use the weapon only once !!!",Black,White);
	sleep(2);
	levelerror.Close();

}


}
}

void wgrenade(int level, float theta, float u,int check)
{
xfinal=100;	
if(check==0)
{	
	if(lgdf==0)
	{
	endgame++;
	lgdf++;
	theta=theta*Pi/180;
	float x, y, y2=0, y3=0,x2=lftdflt,x3=lftdflt;	
	for( x=lftdflt;x<25.5; x+= diff)
	{
	float h =15.5-hght(level,x);
	y = 15.5-hght(level,lftdflt) - 0.01 - (x-lftdflt)*tan(theta) + (g*(x-lftdflt)*(x-lftdflt))/(2*u*u*cos(theta)* cos(theta) );

	mainwindow.RenderEllipse( Position(x-0.25,y-.1),Position(x+0.25,y+.1),Red,false);
	usleep(1000);
	mainwindow.RenderEllipse( Position(x-.25,y-.1),Position(x+.25,y+.1),Blue, false);
	usleep(1000);
	mainwindow.RenderEllipse( Position(x-.1,y-.25),Position(x+.1,y+.25),Red,false);
	usleep(1000);
	mainwindow.RenderEllipse( Position(x-.1,y-.25),Position(x+.1,y+.25),Blue,false);
	usleep(1000);
	if(y>=h)
	{
		break;
	}
	}
	xfinal = x;
	//score(xfinal,check);
	for(float i=0.5;i<=2.0;i+=0.05)
	{
		mainwindow.RenderEllipse( Position(xfinal-i,y-i),Position(xfinal+i,y+i),Red,false);
		usleep(1000);
	}
	
	}
	else
	{
	levelerror.Open();
	levelerror.RenderText(Position(0.0,0.0),Position(10.0,5.0),"Player 1:You can use the weapon only once !!!",Black,White);
	levelerror.RenderText(Position(0.0,0.0),Position(10.0,5.0),"Player 1:You can use the weapon only once !!!",Black,White);
	sleep(2);
	levelerror.Close();
	}
}

if(check==1){
	if(rgdf==0)
	{
	endgame++;
	rgdf++;
	theta=theta*Pi/180;
	float x, y, y2=0, y3=0,x2=rghtdflt,x3=rghtdflt;	
	for( x=rghtdflt;x>-5; x-= diff){
	float h =15.5-hght(level,x);
	y = 15.5-hght(level,rghtdflt) - 0.01 - (rghtdflt-x)*tan(theta) + (g*(rghtdflt-x)*(rghtdflt-x))/(2*u*u*cos(theta)* cos(theta) );

	mainwindow.RenderEllipse( Position(x-0.25,y-.1),Position(x+0.25,y+.1),Red,false);
	usleep(1000);
	mainwindow.RenderEllipse( Position(x-.25,y-.1),Position(x+.25,y+.1),Blue, false);
	usleep(1000);
	mainwindow.RenderEllipse( Position(x-.1,y-.25),Position(x+.1,y+.25),Red,false);
	usleep(1000);
	mainwindow.RenderEllipse( Position(x-.1,y-.25),Position(x+.1,y+.25),Blue,false);
	usleep(1000);
	if(y>=h){
		break;
	}
}
xfinal = x;
//score(xfinal,check);
for(float i=0.5;i<=2.0;i+=0.05)
	{
		mainwindow.RenderEllipse( Position(xfinal-i,y-i),Position(xfinal+i,y+i),Red,false);
		usleep(1000);
	}

}
else{	
	levelerror.Open();
	levelerror.RenderText(Position(0.0,0.0),Position(10.0,5.0),"Player 2:You can use the weapon only once !!!",Black,White);
	levelerror.RenderText(Position(0.0,0.0),Position(10.0,5.0),"Player 2:You can use the weapon only once !!!",Black,White);
	sleep(2);
	levelerror.Close();

}
}

//score(xfinal,check);
	
}

void wsingleshot(int level,float theta,float u,int check){
xfinal=100;

if(check==0){
	if(lsf==0){
	endgame++;
	lsf++;
	float x,x1,y[2];
	int flag=1;



	theta=theta*Pi/180;



	  for( x=lftdflt;x<25;x+=diff)
	{
	x1=x-0.2;
	 y[0] = 15.5-hght(level,lftdflt) - 0.01 - (x-lftdflt)*tan(theta) + (g*(x-lftdflt)*(x-lftdflt))/(2*u*u*cos(theta)* cos(theta) ); 
	if(flag!=0) 
	{if(y[0]<(15.5-hght(level,x)))
        mainwindow.RenderRectangle (Position(x-0.2,y[0]-0.2),Position(x+0.2,y[0]+0.2),Red,false) ;
	}    
	else
  	flag=0; 

  

	y[1] = 15.5-hght(level,lftdflt) - 0.01 - (x1-lftdflt)*tan(theta) + (g*(x1-lftdflt)*(x1-lftdflt))/(2*u*u*cos(theta)* cos(theta) );


	   if(y[1]<(15.5-hght(level,x1))){
	  mainwindow.RenderRectangle (Position(x1-0.2,y[1]-0.2),Position(x1+0.2,y[1]+0.2),Blue,false) ;
		xfinal=x;
	}


	 usleep(1000);
	//score(xfinal,check);
	}
	}
	else
	{	
	levelerror.Open();
	levelerror.RenderText(Position(0.0,0.0),Position(10.0,5.0),"Player 1:You can use the weapon only once !!!",Black,White);
	levelerror.RenderText(Position(0.0,0.0),Position(10.0,5.0),"Player 1:You can use the weapon only once !!!",Black,White);
	sleep(2);
	levelerror.Close();

	}
	}
	

else if(check==1){
	if(rsf==0){
	endgame++;
	rsf++;
	float x,x1,y[2];
	int flag=1;
	theta=theta*Pi/180;
	


	for( x=rghtdflt;x>-5;x-=diff)
	{
	x1=x+0.2;
	 y[0] = 15.5-hght(level,rghtdflt) - 0.01 - (rghtdflt-x)*tan(theta) + (g*(rghtdflt-x)*(rghtdflt-x))/(2*u*u*cos(theta)* cos(theta) ); 
	if(flag!=0) 
	if(y[0]<(15.5-hght(level,x))){
        mainwindow.RenderRectangle (Position(x-0.2,y[0]-0.2),Position(x+0.2,y[0]+0.2),Red,false) ;
        xfinal=x;
	}
	else
        flag=0; 
	y[1] = 15.5-hght(level,rghtdflt) - 0.01 - (rghtdflt-x1)*tan(theta) + (g*(rghtdflt-x1)*(rghtdflt-x1))/(2*u*u*cos(theta)* cos(theta) );


	if(y[1]<(15.5-hght(level,x1)))
        mainwindow.RenderRectangle (Position(x1-0.2,y[1]-0.2),Position(x1+0.2,y[1]+0.2),Blue,false) ;
	usleep(1000);

	}
	//score(xfinal,check);
	}
	else{	
	levelerror.Open();
	levelerror.RenderText(Position(0.0,0.0),Position(10.0,5.0),"Player 2:You can use the weapon only once !!!",Black,White);
	levelerror.RenderText(Position(0.0,0.0),Position(10.0,5.0),"Player 2:You can use the weapon only once !!!",Black,White);
	sleep(2);
	levelerror.Close();

	}
	}
	
	}




void whoming(int level,float theta,float u,int check){
	xfinal=100;
	if(check==0){
		if(lhf==0)
		{
			endgame++;
			lhf++;
			float x,x1,y[3];
			int flag=1;
			theta=theta*Pi/180;

			for( x=lftdflt;x<=rghtdflt+1;x+=diff)
				{
					x1=x-0.2;
					y[0] = 15.5-hght(level,lftdflt) - 0.01 - (x-lftdflt)*tan(theta) + (g*(x-lftdflt)*(x-lftdflt))/(2*u*u*cos(theta)* cos(theta) ); 
					if(flag!=0) 
					{
						if(y[0]<(15.5-hght(level,x)))
   						{
		 					mainwindow.RenderRectangle (Position(x-0.2,y[0]-0.2),Position(x+0.2,y[0]+0.2),Red,false) ;
   						 	xfinal = x;
						}
						else
						flag=0; 
 					}
					y[1] = 15.5-hght(level,lftdflt) - 0.01 - (x1-lftdflt)*tan(theta) + (g*(x1-lftdflt)*(x1-lftdflt))/(2*u*u*cos(theta)* cos(theta) );
					  if(y[1]<(15.5-hght(level,x1)))
					  {
						  mainwindow.RenderRectangle (Position(x1-0.2,y[1]-0.2),Position(x1+0.2,y[1]+0.2),Blue,false) ;

					  }
					usleep(1000);

				}
					if(flag!=0)
					{
						for(y[2]=y[0];y[2]<(15.5-hght(level,rghtdflt+1));y[2]+=diff)
						{
							y[1]=y[2]-1;
							mainwindow.RenderRectangle (Position(rghtdflt+1-0.2,y[2]-0.2),Position(rghtdflt+1+0.2,y[2]+0.2),Red,false) ;
 
							mainwindow.RenderRectangle (Position(rghtdflt+1-0.2,y[1]-0.2),Position(rghtdflt+1+0.2,y[1]+0.2),Blue,false) ;

							usleep(1000);
						}
						xfinal=rghtdflt+1;
					}
//score(xfinal,check);
			}
	else
	{	
	levelerror.Open();
	levelerror.RenderText(Position(0.0,0.0),Position(10.0,5.0),"Player 1:You can use the weapon only once !!!",Black,White);
	levelerror.RenderText(Position(0.0,0.0),Position(10.0,5.0),"Player 1:You can use the weapon only once !!!",Black,White);
	sleep(2);
	levelerror.Close();

	}
}

if(check==1){
		if(rhf==0)
		{
			endgame++;
			rhf++;
			float x,x1,y[3];
			int flag=1;
			theta=theta*Pi/180;

			for( x=rghtdflt;x>=lftdflt+1;x-=diff)
			{
				x1=x+0.2;
				y[0] = 15.5-hght(level,rghtdflt) - 0.01 - (rghtdflt-x)*tan(theta) + (g*(rghtdflt-x)*(rghtdflt-x))/(2*u*u*cos(theta)* cos(theta) ); 
				if(flag!=0) 
				{
					if(y[0]<(15.5-hght(level,x)))
					{
	    					mainwindow.RenderRectangle (Position(x-0.2,y[0]-0.2),Position(x+0.2,y[0]+0.2),Red,false) ;
	     					xfinal = x;
					}
					else
					flag=0; 
				} 
				y[1] = 15.5-hght(level,rghtdflt) - 0.01 - (rghtdflt-x1)*tan(theta) + (g*(rghtdflt-x1)*(rghtdflt-x1))/(2*u*u*cos(theta)* cos(theta) );
				if(y[1]<(15.5-hght(level,x1)))
				{
					mainwindow.RenderRectangle (Position(x1-0.2,y[1]-0.2),Position(x1+0.2,y[1]+0.2),Blue,false) ;
				}
 				usleep(1000);	

			}
			if(flag!=0)
			{
				for(y[2]=y[0];y[2]<(15.5-hght(level,lftdflt+1));y[2]+=diff)
				{
					y[1]=y[2]-1;
					mainwindow.RenderRectangle (Position(lftdflt+1-0.2,y[2]-0.2),Position(lftdflt+1+0.2,y[2]+0.2),Red,false) ;
 
					mainwindow.RenderRectangle (Position(lftdflt+1-0.2,y[1]-0.2),Position(lftdflt+1+0.2,y[1]+0.2),Blue,false) ;

					usleep(1000);
				}
				xfinal=lftdflt+1;
			}
//score(xfinal,check);
		}
		else{	
		levelerror.Open();
		levelerror.RenderText(Position(0.0,0.0),Position(10.0,5.0),"Player 2:You can use the weapon only once !!!",Black,White);
		levelerror.RenderText(Position(0.0,0.0),Position(10.0,5.0),"Player 2:You can use the weapon only once !!!",Black,White);
		sleep(2);
		levelerror.Close();
		
		}
	}

}

void drawgetdata()
{	getdata.Open();
	selectangle.Load("selectangle.xpm");
	assert(selectangle.GetStatus() == BitMapOkay);
	selectangle.SetPosition(Position(0.0, 0.0));	     
    	selectangle.Draw();

	if(check==0)
	{	
	quarterl.Load("quarterl.xpm");
	assert(quarterl.GetStatus() == BitMapOkay);
	quarterl.SetPosition(Position(0.5, 1.0));	     
    	quarterl.Draw();
	}
	if(check==1)
	{	
	quarterr.Load("quarterr.xpm");
	assert(quarterr.GetStatus() == BitMapOkay);
	quarterr.SetPosition(Position(1.5, 1.0));	     
    	quarterr.Draw();
	}

	selectspeed.Load("selectspeed.xpm");
	assert(selectspeed.GetStatus() == BitMapOkay);
	selectspeed.SetPosition(Position(0.0, 5.5));	     
    	selectspeed.Draw();

	stline.Load("stline.xpm");
	assert(stline.GetStatus() == BitMapOkay);
	stline.SetPosition(Position(0.5, 7.5));	     
    	stline.Draw();
	
	fire.Load("fire.xpm");
	assert(fire.GetStatus() == BitMapOkay);
	fire.SetPosition(Position(1.25, 13.75));	     
    	fire.Draw();
	
	grazer.Load("grazer.xpm");
	assert(grazer.GetStatus() == BitMapOkay);
	grazer.SetPosition(Position(.5, 8.75));	     
    	grazer.Draw();

	threeshot.Load("threeshot.xpm");
	assert(threeshot.GetStatus() == BitMapOkay);
	threeshot.SetPosition(Position(.5, 9.75));	     
    	threeshot.Draw();
	getdata.SetMouseClickCallback(MouseClickEvent4);

	grenade.Load("grenade.xpm");
	assert(grenade.GetStatus() == BitMapOkay);
	grenade.SetPosition(Position(.5, 10.75));	     
    	grenade.Draw();
	getdata.SetMouseClickCallback(MouseClickEvent4);

	homing.Load("homing.xpm");
	assert(homing.GetStatus() == BitMapOkay);
	homing.SetPosition(Position(.5, 11.75));	     
    	homing.Draw();
	getdata.SetMouseClickCallback(MouseClickEvent4);

	single.Load("single.xpm");
	assert(single.GetStatus() == BitMapOkay);
	single.SetPosition(Position(.5, 12.75));	     
    	single.Draw();
	getdata.SetMouseClickCallback(MouseClickEvent4);
}

int MouseClickEvent4(const Position &p)
{
	if(quarterl.IsInside(p))
	{
		float xpl=(float)(p.GetXDistance());
		float ypl=(float)(p.GetYDistance());
		ypl=3.6-ypl;
		xpl=xpl-0.5;
		int anglel=(atan(ypl/xpl))*180/Pi;
		angll=(atan(ypl/xpl))*180/Pi;
		char angl[3];
		angl[0]=(anglel/10)+48;
		angl[1]=(anglel%10)+48;
		angl[2]='\0';
		//cout<<ang<<endl;
		//getdata.Close();
		//drawgetdata();		
		getdata.RenderText(Position(0.0,3.5),Position(3.0,4.5),"Current Angle:",Black,White);
		getdata.RenderText(Position(3.0,3.5),Position(5.0,4.5),angl,Red,White);
		angle=angll;
	}

	if(quarterr.IsInside(p))
	{
		float xpr=(float)(p.GetXDistance());
		float ypr=(float)(p.GetYDistance());
		ypr=3.6-ypr;
		xpr=4-xpr;
		int angler=(atan(ypr/xpr))*180/Pi;
		anglr=(atan(ypr/xpr))*180/Pi;
		char angr[3];
		angr[0]=(angler/10)+48;
		angr[1]=(angler%10)+48;
		angr[2]='\0';
		//cout<<ang<<endl;
		//getdata.Close();
		//drawgetdata();		
		getdata.RenderText(Position(0.0,3.5),Position(3.0,4.5),"Current Angle:",Black,White);
		getdata.RenderText(Position(3.0,3.5),Position(5.0,4.5),angr,Red,White);
		angle=anglr;
	}
    	if(stline.IsInside(p))
	{
		float length=((p.GetXDistance())-0.5);
		int speed=(length/2.533)*30;
		spd=(length/2.533)*30;
		char vel[3];
		vel[0]=(speed/10)+48;
		vel[1]=(speed%10)+48;
		vel[2]='\0';
		//getdata.Close();
		//drawgetdata();
		getdata.RenderText(Position(0.0,6.6),Position(3.0,7.6),"Current Speed:",Black,White);
		getdata.RenderText(Position(3.0,6.6),Position(5.0,7.6),vel,Red,White);
		//speed
    	}
 
if(check==0){
	if(grazer.IsInside(p))
	{
		weapon=1;
    	}
        if(threeshot.IsInside(p))
	{
		weapon=2;
    	}
        if(grenade.IsInside(p))
	{
		weapon=3;
    	}
	if(homing.IsInside(p))
	{
		weapon=4;
    	}
	if(single.IsInside(p))
	{
		weapon=5;
    	}
	if(fire.IsInside(p))
	{	//getdata.Close();
		//drawgetdata();	
		switch(weapon)
		{
			case 1:
				wgrazer(lvel,angle,spd,check);
				score(xfinal,check);
				check++;
				check=check%2;	
				getdata.Close();
				drawgetdata();	
				break;
			case 2:
				wthreeshot(lvel,angle,spd,check);
				score(xfinal,check);
				check++;
				check=check%2;	
				getdata.Close();
				drawgetdata();	
				break;
			case 3:
				wgrenade(lvel,angle,spd,check);
				score(xfinal,check);
				check++;
				check=check%2;	
				getdata.Close();
				drawgetdata();	
				break;
			case 4:
				whoming(lvel,angle,spd,check);
				score(xfinal,check);
				check++;
				check=check%2;	
				getdata.Close();
				drawgetdata();	
				break;
			case 5:
				wsingleshot(lvel,angle,spd,check);
				score(xfinal,check);
				check++;
				check=check%2;	
				getdata.Close();
				drawgetdata();	
				break;
		}
		drawterrain(lvel);
		drwlfttnk(lftdflt,lvel);
		drwrghttnk(rghtdflt,lvel);
		drwrghttnk(rghtdflt,lvel);
		
	}
}

else if(check==1){
	if(grazer.IsInside(p))
	{
		weapon=1;
    	}
        if(threeshot.IsInside(p))
	{
		weapon=2;
    	}
        if(grenade.IsInside(p))
	{
		weapon=3;
    	}
	if(homing.IsInside(p))
	{
		weapon=4;
    	}
	if(single.IsInside(p))
	{
		weapon=5;
    	}
		
	if(fire.IsInside(p))
	{	//getdata.Close();
		//drawgetdata();	
	
		switch(weapon)
		{
			case 1:
				wgrazer(lvel,angle,spd,check);
				score(xfinal,check);
				check++;
				check=check%2;
				getdata.Close();
				drawgetdata();
				break;
			case 2:
				wthreeshot(lvel,angle,spd,check);
				score(xfinal,check);
				check++;
				check=check%2;	
				getdata.Close();
				drawgetdata();	
				break;
			case 3:
				wgrenade(lvel,angle,spd,check);
				score(xfinal,check);
				check++;
				check=check%2;	
				getdata.Close();
				drawgetdata();	
				break;
			case 4:
				whoming(lvel,angle,spd,check);
				score(xfinal,check);
				check++;
				check=check%2;	
				getdata.Close();
				drawgetdata();	
				break;
			case 5:
				wsingleshot(lvel,angle,spd,check);
				score(xfinal,check);				
				check++;
				check=check%2;	
				getdata.Close();
				drawgetdata();	
				break;
		}
		drawterrain(lvel);
		drwlfttnk(lftdflt,lvel);
		drwrghttnk(rghtdflt,lvel);
		drwrghttnk(rghtdflt,lvel);

	}

}
}	

void score(float xfinal, int check){
	float yfinal=15.5-hght(lvel,xfinal);
	float yrdflt=15.5-hght(lvel,rghtdflt);
	float yldflt=15.5-hght(lvel,lftdflt);
	
	float distl = sqrt((xfinal-rghtdflt)*(xfinal-rghtdflt)+(yfinal-yrdflt)*(yfinal-yrdflt));
	float distr = sqrt((xfinal-lftdflt)*(xfinal-lftdflt)+(yfinal-yldflt)*(yfinal-yldflt));

	if(check==0){
		if(distl<=2.0){
			scorel+=100;
		}
		else if(distl>2.0 && distl<=4.0){
			scorel+=50;
		}
	}
	else if(check==1){
		if(distr<=2.0){
			scorer+=100;
		}
		else if(distr>2.0 && distr<=4.0){
			scorer+=50;
		}
	}
	char scorl[10]="0",scorr[10]="0";
	int countl=0,countr=0;
	int j;
	int scorel1=scorel,scorer1=scorer;
	for(j=0;scorel1!=0;j++)
	{
		countl++;
		scorl[j]=(scorel1%10)+48;
		scorel1=scorel1/10;
	}
	scorl[countl]='\0';
	for(j=0;scorer1!=0;j++)
	{
		countr++;
		scorr[j]=(scorer1%10)+48;
		scorer1=scorer1/10;
	}
	scorr[countr]='\0';
	reverse_string(scorl);
	reverse_string(scorr);
	mainwindow.RenderText(Position(0.0,0.5),Position(4,1.5),pname1,White,Black);
	mainwindow.RenderText(Position(11.5,0.5),Position(15.5,1.5),pname2,White,Black);
	mainwindow.RenderText(Position(4.5,0.5),Position(6.5,1.5),scorl,White,Black);
	mainwindow.RenderText(Position(15.5,0.5),Position(17.5,1.5),scorr,White,Black);
	xfinal=100;
}
int ApiMain()
{
	drawmainmenu();
	entername.Open();
	drawkeyboard();
	
return 0;
}

